#
# Simple debug logging facility
#
# Jason Vas Dias, Red Hat Inc., Oct. 2004

import __builtin__
import sys
import datetime

DEBUG=None
DEBUG_TIME=None
DEBUG_FRAME=None
DEBUG_FILES=None
DEBUG_CWD=None

def parseEnv( dbg, m ):
    dbgs=dbg.split(',')
    for d in dbgs:
        if d.lower() == 'time':
            m.DEBUG_TIME = 1
        elif d.lower() == 'frame':
            m.DEBUG_FRAME = 1
        elif len(d):
            m.DEBUG_FRAME = 1
            if( m.DEBUG_FILES == None ):
                m.DEBUG_FILES = []
            m.DEBUG_FILES.append(d)            

def debug(*args):
    if DEBUG == None:
        return    
    o=''
    if DEBUG_TIME != None:
        d=datetime.datetime.now()
        o+=('%.4d' % d.year)+'-'+('%0.2d' % d.month)+'-'+('%0.2d' % d.day)+'_'+('%0.2d' % d.hour)+':'+('%0.2d' % d.minute)+':'+('%0.2d' % d.second)+'.'+('%0.6d' % d.microsecond)+' '
    match=True
    if DEBUG_FRAME != None:
        f=sys._getframe().f_back
        fName=f.f_code.co_filename
        if (DEBUG_CWD != None) and (len(fName) > len(DEBUG_CWD)) and (fName[:len(DEBUG_CWD)]==DEBUG_CWD):
            fName = fName[len(DEBUG_CWD)+1:]
        if (len(fName)>=2) and (fName[:2] == './'):
            fName=fName[2:]
        if( (fName[0]=='/') and
            (fName in [ '/usr/sbin/system-config-bind', '/usr/sbin/system-config-bind-gui',
                        '/usr/bin/bindconf', '/usr/bin/system-config-bind'
                      ]
            )
          ): fName = 'GUI.py'
        if DEBUG_FILES != None:
            match = False
            for fn in DEBUG_FILES:
#                print 'DEBUG: FN:',fn,fName
                i=fn.find(':')
                if i > -1:
                    lineNo=fn[i+1:]
                    maxLineNo=None
                    j=lineNo.find('-')
                    if j > -1:
                        maxLineNo = lineNo[j+1:]
                        lineNo = lineNo[:j]
                    try:
                        lineNo = int(lineNo)
                    except ValueError:
                        lineNo = None
                    if maxLineNo != None:
                        try:
                            maxLineNo = int(maxLineNo)
                        except ValueError:
                            maxLineNo = None
#                    print 'DEBUG:', fn[0:i], fName, f.f_code.co_firstlineno, lineNo, maxLineNo
                    if( (fn[0:i] == fName) and
                        (  (lineNo == None)
                         or((maxLineNo==None) and (lineNo != None) and (f.f_code.co_firstlineno==lineNo))
                         or((maxLineNo!=None) and (lineNo != None) and
                            (f.f_code.co_firstlineno >= lineNo) and
                            (f.f_code.co_firstlineno <= maxLineNo)
                           )
                         )
                       ):
                        match = True
                elif (fn == fName):
                    match=True
        if match:
            o += fName + ':' + str(f.f_code.co_firstlineno) + ' (' + f.f_code.co_name +')' + ': '
    if not match:
        return
    for a in args:
        o += str(a) + ' '
    o+='\n'
    sys.__stderr__.write(o)
    
__builtin__.__dict__['debug']=debug    

