import gtk
import gtk.glade
import gnome.ui
import gnome
import gobject

class ErrorDialog:
    def __init__(s, gui, title, text, fatal=False, parent=False, warning=False, question=False, info=False, modal=gtk.DIALOG_MODAL ):
        s.gui = gui
        if parent == False:
            parent = gui.gui            
        im=gtk.Image()
        if warning == True:
            s.dialog = gtk.Dialog(_('Warning'),
                                  parent,
                                  gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                                  (gtk.STOCK_OK, gtk.RESPONSE_OK)                                  
                                  )
            if(title==None):
                title = _('Warning')
            im.set_from_stock(gtk.STOCK_DIALOG_WARNING, gtk.ICON_SIZE_DIALOG )                
        elif info == True:
            s.dialog = gtk.Dialog(_('Information'),
                                  parent,
                                  gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                                  (gtk.STOCK_OK, gtk.RESPONSE_OK)                                  
                                  )
            if(title==None):
                title = _('Information')
            im.set_from_stock(gtk.STOCK_DIALOG_INFO, gtk.ICON_SIZE_DIALOG )                                
        elif question == True:
            s.dialog = gtk.Dialog(_('Question'),
                                  parent,
                                  modal | gtk.DIALOG_DESTROY_WITH_PARENT,
                                  (gtk.STOCK_YES, gtk.RESPONSE_OK,
                                   gtk.STOCK_NO, gtk.RESPONSE_CANCEL
                                  )
                                 )
            if(title==None):
                title = _('Question')
            im.set_from_stock(gtk.STOCK_DIALOG_QUESTION, gtk.ICON_SIZE_DIALOG )
        else:
            s.dialog = gtk.Dialog(_('Error'),
                                  parent,
                                  gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                                  (gtk.STOCK_OK, gtk.RESPONSE_OK)
                                  )
            if(title==None):
                title = _('Error')
            im.set_from_stock(gtk.STOCK_DIALOG_ERROR, gtk.ICON_SIZE_DIALOG )
        frame = gtk.Frame()
        s.errorTitle = gtk.Label()
        s.errorTitle.set_markup('<b>'+title+'</b>')
        frame.set_label_widget(s.errorTitle)
        s.errorText =  gtk.Label()
        s.errorText.set_text(text)
        s.dialog.vbox.pack_start(frame)
        hb=gtk.HBox()
        hb.pack_start(im)
        hb.pack_start(s.errorText)
        frame.add(hb)
        s.dialog.connect('response',s.on_exit)
        s.dialog.connect('delete_event', s.on_delete_event)
        s.dialog.connect('destroy_event', s.on_delete_event)
        if( fatal == True ):
            s.gui.fatal_error = True
        s.dialog.vbox.resize_children()
        if not question:
            s.dialog.show_all()
        if not gui.running and not question:
            debug( 'ERROR DIALOG: RUN')
            s.dialog.run()
            debug( 'ERROR DIALOG: RUN FINISH')

    def question(s, callback=None, parms=None):
        s.dialog.show_all()
        if ( callback == None):
            debug( 'ErrorDialog RUN')
            return s.dialog.run()
        else:
            s.callback = callback
            s.parms = parms
        return
        
    def on_exit(self, dialog, response):
        if response == 0xDEAD:
            return False
        debug( 'ERROR DIALOG: EXIT:', self.gui.running, self.gui.fatal_error)
        if self.gui.fatal_error:
            self.gui.exit()
        self.response = response
        if hasattr(self,'callback'):
            self.callback(response,self.parms)
        if not self.gui.running:
            dialog.hide()
            dialog.response(0xDEAD)
        else:
            dialog.destroy()            
        return False

    def on_delete_event(self, widget, event, data=None):
        debug( 'ERROR DIALOG: EXIT:', self.gui.running, self.gui.fatal_error)
        if  self.gui.fatal_error:
            self.gui.exit()
        if not self.gui.running:
            dialog.hide()
            dialog.response(0xDEAD)
        else:
            dialog.destroy()                        
        return True
